--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_df.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_df.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,398 @@
+#ifndef __CNC1900_DF_H__
+#define __CNC1900_DF_H__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define  CSTVE_IOC_MAGIC  'e'
+#define  CSDF_IOC_MAGIC   'x'
+
+/*****************IOCTL for TVE******************/
+#define CSTVE_IOC_ENABLE                      _IOW(CSTVE_IOC_MAGIC, 0x0b, int)
+#define CSTVE_IOC_DISABLE                     _IOR(CSTVE_IOC_MAGIC, 0x0c, int)
+#define CSTVE_IOC_SET_MODE                    _IOW(CSTVE_IOC_MAGIC, 0x01, int)
+#define CSTVE_IOC_GET_MODE                    _IOW(CSTVE_IOC_MAGIC, 0x02, int)
+#define CSTVE_IOC_SET_WHILE_LEVEL             _IOW(CSTVE_IOC_MAGIC, 0x03, int)
+#define CSTVE_IOC_GET_WHILE_LEVEL             _IOR(CSTVE_IOC_MAGIC, 0x04, int)
+#define CSTVE_IOC_SET_BLACK_LEVEL             _IOW(CSTVE_IOC_MAGIC, 0x05, int)
+#define CSTVE_IOC_GET_BLACK_LEVEL             _IOR(CSTVE_IOC_MAGIC, 0x06, int)
+#define CSTVE_IOC_SET_SATURATION_LEVEL        _IOW(CSTVE_IOC_MAGIC, 0x07, int)
+#define CSTVE_IOC_GET_SATURATION_LEVEL        _IOR(CSTVE_IOC_MAGIC, 0x08, int)
+#define CSTVE_IOC_SET_COMP_CHAN               _IOW(CSTVE_IOC_MAGIC, 0x15, int)
+#define CSTVE_IOC_SET_COLOR_MODULATOR_COEF    _IOW(CSTVE_IOC_MAGIC, 0x16, int)
+
+/* dual output */
+#define CSTVE_IOC_BIND_GFX                    _IOW(CSTVE_IOC_MAGIC, 0x17, int)
+#define CSTVE_IOC_BIND_VID                    _IOW(CSTVE_IOC_MAGIC, 0x18, int)
+#define CSTVE_IOC_SET_OUTPUT                  _IOW(CSTVE_IOC_MAGIC, 0x19, int)
+#define CSTVE_IOC_GET_BIND_INF                _IOW(CSTVE_IOC_MAGIC, 0x20, int)
+
+#define CSTVE_IOC_WSS_CTRL                    _IOW(CSTVE_IOC_MAGIC, 0x22, int)
+#define CSTVE_IOC_WSS_SETCONFIG               _IOW(CSTVE_IOC_MAGIC, 0x23, int)
+#define CSTVE_IOC_WSS_SETINFO                 _IOW(CSTVE_IOC_MAGIC, 0x24, int)
+#define CSTVE_IOC_TTX_CTRL                    _IOW(CSTVE_IOC_MAGIC, 0x25, int)
+#define CSTVE_IOC_TTX_SETCONFIG               _IOW(CSTVE_IOC_MAGIC, 0x26, int)
+#define CSTVE_IOC_TTX_SETINFO                 _IOW(CSTVE_IOC_MAGIC, 0x27, int)
+
+
+/*******IOCTL for Display Feeder ********/
+#define CSDF_IOC_DISP_ON                      _IOW(CSDF_IOC_MAGIC, 0x0F, int)
+#define CSDF_IOC_DISP_OFF                     _IOW(CSDF_IOC_MAGIC, 0x10, int)
+#define CSDF_IOC_DISP_VID_ON                  _IOW(CSDF_IOC_MAGIC, 0x11, int)
+#define CSDF_IOC_DISP_VID_OFF                 _IOW(CSDF_IOC_MAGIC, 0x12, int)
+#define CSDF_IOC_DISP_GFX_ON                  _IOW(CSDF_IOC_MAGIC, 0x1C, int)
+#define CSDF_IOC_DISP_GFX_OFF                 _IOW(CSDF_IOC_MAGIC, 0x1D, int)
+#define CSDF_IOC_DISP_POS                     _IOW(CSDF_IOC_MAGIC, 0x13, df_output_pos)
+//#define CSDF_IOC_DISP_GET_POS               _IOW(CSDF_IOC_MAGIC, 0x14, int)
+#define CSDF_IOC_DISP_VID_ALPHA               _IOW(CSDF_IOC_MAGIC, 0x15, int)
+//#define CSDF_IOC_DISP_GET_ALPHA             _IOW(CSDF_IOC_MAGIC, 0x16, int)
+#define CSDF_IOC_DISP_VIDFMT                  _IOW(CSDF_IOC_MAGIC, 0x18, int)
+#define CSDF_IOC_Z_ORDER                      _IOW(CSDF_IOC_MAGIC, 0x19, int)
+#define CSDF_IOC_GET_Z_ORDER                _IOW(CSDF_IOC_MAGIC, 0x1A, int)
+#define CSDF_IOC_DISP_SETBGCOLOR              _IOW(CSDF_IOC_MAGIC, 0x1B, int)
+#define CSDF_IOC_DISP_SETMODE                 _IOW(CSDF_IOC_MAGIC, 0x1E, int)
+//#define CSDF_IOC_DISP_CROP                  _IOW(CSDF_IOC_MAGIC, 0x1F, struct df_vid_crop)
+#define CSDF_IOC_DISP_HD2SD_ENABLE            _IOW(CSDF_IOC_MAGIC, 0x20, int)
+#define CSDF_IOC_DISP_HD2SD_CONFIG            _IOW(CSDF_IOC_MAGIC, 0x21, int)
+
+#define CSDF_IOC_SET_BRIGHTNESS               _IOW(CSDF_IOC_MAGIC, 0x22, int)
+#define CSDF_IOC_GET_BRIGHTNESS               _IOR(CSDF_IOC_MAGIC, 0x23, int)
+#define CSDF_IOC_SET_CONTRAST                 _IOW(CSDF_IOC_MAGIC, 0x24, int)
+#define CSDF_IOC_GET_CONTRAST                 _IOR(CSDF_IOC_MAGIC, 0x25, int)
+#define CSDF_IOC_SET_SATURATION               _IOW(CSDF_IOC_MAGIC, 0x26, int)
+#define CSDF_IOC_GET_SATURATION               _IOR(CSDF_IOC_MAGIC, 0x27, int)
+
+#define CSDF_IOC_GET_INIT_OUTPUTMODE		  _IOW(CSDF_IOC_MAGIC, 0x28, int)
+#define CSDF_IOC_GET_IDCS_DDR_DIV_VAL		  _IOW(CSDF_IOC_MAGIC, 0x29, int)
+#define CSDF_IOC_GET_VPP_REG_ADDR		  _IOW(CSDF_IOC_MAGIC, 0x2a, int)
+#define CSDF_IOC_GET_VPP_REG_SIZE		  _IOW(CSDF_IOC_MAGIC, 0x2b, int)
+
+#define CSTVE_IOC_SET_HDMI_IN_ENBALE              _IOW(CSTVE_IOC_MAGIC, 0x2c, int)
+#define CSTVE_IOC_SET_HDMI_IN_BYPASS             _IOW(CSTVE_IOC_MAGIC, 0x2d, int)
+
+#define CSDF_IOC_SET_SHARPNESS               _IOW(CSDF_IOC_MAGIC, 0x2e, int)
+#define CSDF_IOC_GET_SHARPNESS               _IOR(CSDF_IOC_MAGIC, 0x2f, int)
+
+typedef enum
+{
+	CSVOUT_COMP_YVU = 0,
+	CSVOUT_COMP_RGB
+
+}CSVOUT_CompChannType_t;
+
+typedef enum {
+	DF_DEV_NUKOWN = -1,
+	DF_DEV_GFX0 = 0,
+	DF_DEV_GFX1,
+	DF_DEV_VIDEO0,
+	DF_DEV_VIDEO1,
+	DF_DEV_OUT0,
+	DF_DEV_OUT1,
+	DF_DEV_TVE0,
+	DF_DEV_TVE1,
+	DF_DEV_MAX
+} DF_DEV_TYPE;
+
+typedef enum _DF_VIDEO_FORMAT_
+{
+	NOT_STANDARD_VIDEO_MODE = -1,		
+	DISP_YUV_720P_60FPS        =0,    
+	DISP_YUV_1080I_30FPS       =1,   
+	DISP_YUV_480P              =2,          
+	DISP_YUV_NTSC              =3,          
+	DISP_YUV_720P_50FPS        =4,    
+	DISP_YUV_1080I_25FPS       =5,   
+	DISP_YUV_576P              =6,          
+	DISP_YUV_PAL               =7,           
+	DISP_YUV_1080P_60FPS       =8,   
+	DISP_YUV_1080P_50FPS       =9,   
+	DISP_YUV_1080P_24FPS       =10,   
+	DISP_YUV_1080P_25FPS       =11,   
+	DISP_YUV_1080P_30FPS       =12,   
+	DISP_YUV_1080I_25FPS_AS    =13,
+	DISP_RGB_VGA_60FPS         =14,     
+	DISP_RGB_SVGA_60FPS        =15,    
+	DISP_RGB_XGA_60FPS         =16,     
+	DISP_RGB_SXGA_60FPS        =17,    
+	DISP_RGB_UXGA_60FPS        =18,
+	DISP_RGB_720P_60FPS        =19,
+	DISP_1440x288P_50_M1       =20,   
+	DISP_1440x288P_50_M2       =21,   
+	DISP_1440x288P_50_M3       =22,   
+	DISP_2880x576I_50          =23,      
+	DISP_2880x288P_50_M1       =24,   
+	DISP_2880x288P_50_M2       =25,   
+	DISP_2880x288P_50_M3       =26,   
+	DISP_1440x576P_50          =27,      
+	DISP_1440x240P_60_M1       =28,   
+	DISP_1440x240P_60_M2       =29,   
+	DISP_2880x480I_60          =30,      
+	DISP_2880x240P_60_M1       =31,   
+	DISP_2880x240P_60_M2       =32,   
+	DISP_1440x480P_60          =33,
+	DISP_RGB_DMT_640x480_60    =34,    
+	DISP_RGB_DMT_640x480_75    =35,    
+	DISP_RGB_DMT_800x600_60    =36,    
+	DISP_RGB_DMT_800x600_75    =37,    
+	DISP_RGB_DMT_848x480_60    =38,    
+	DISP_RGB_DMT_1152x864_75   =39,   
+	DISP_RGB_DMT_1280x768_60   =40,   
+	DISP_RGB_DMT_1280x960_60   =41,   
+	DISP_RGB_DMT_1280x1024_60  =42,  
+	DISP_RGB_DMT_1360x768_60   =43,   
+	DISP_RGB_DMT_1440x900_60   =44,   
+	DISP_RGB_CVT_640x480_75    =45,    
+	DISP_RGB_CVT_800x600_60    =46,    
+	DISP_RGB_CVT_800x600_75    =47,    
+	DISP_RGB_CVT_1024x768_60   =48,   
+	DISP_RGB_CVT_1280x1024_60  =49,  
+	DISP_RGB_CVT_848x480_60    =50,    
+	DISP_RGB_CVT_848x480_75    =51,    
+	DISP_RGB_CVT_1024x576_60   =52,   
+	DISP_RGB_CVT_1024x576_75   =53,   
+	DISP_RGB_CVT_1280x720_60   =54,   
+	DISP_RGB_CVT_1280x720_75   =55,   
+	DISP_RGB_CVT_640x400_75    =56,    
+	DISP_RGB_CVT_768x480_60    =57,    
+	DISP_RGB_CVT_768x480_75    =58,    
+	DISP_RGB_CVT_1024x640_60   =59,   
+	DISP_RGB_CVT_1024x640_75   =60,   
+	DISP_RGB_CVT_1280x800_75   =61,   
+	DISP_RGB_CVT_800x600_RED   =62,   
+	DISP_RGB_CVT_1024x768_RED  =63,  
+	DISP_RGB_CVT_1280x960_RED  =64,  
+	DISP_RGB_CVT_848x480_RED   =65,   
+	DISP_RGB_CVT_1024x576_RED  =66,  
+	DISP_RGB_CVT_1280x720_RED  =67,  
+	DISP_RGB_CVT_1600x900_RED  =68,  
+	DISP_RGB_CVT_768x480_RED   =69,   
+	DISP_RGB_CVT_1024x640_RED  =70,  
+	DISP_RGB_CVT_1280x800_RED  =71,  
+	DISP_RGB_CVT_1600x1000_RED =72, 
+    	DISP_64x64                 =73,
+    	DISP_VGA_1366x768		   =74,
+    	DISP_YUV_480P_3D,
+	DISP_YUV_NTSC_3D,          
+	DISP_YUV_576P_3D,          
+	DISP_YUV_PAL_3D,  
+	DISP_YUV_720P_60FPS_3D,
+	DISP_YUV_1080P_30FPS_3D,
+	DISP_YUV_1080I_30FPS_3D,
+	DISP_YUV_720P_50FPS_3D,
+	DISP_YUV_1080P_24FPS_3D,
+	DISP_YUV_1080P_25FPS_3D,
+	DISP_YUV_720P_30FPS_3D,
+	DISP_YUV_1080P_30FPS_3D_TEMP,
+	DISP_YUV_1080I_30FPS_3D_TEMP,
+	DISP_RGB_VGA_59P94FPS,
+	DISP_1600x1200_60FPS,
+ 	DISP_FMT_MAX,
+}DF_VIDEO_FORMAT;
+
+typedef enum
+{
+	TVOUT_MODE_576I = 0,
+	TVOUT_MODE_480I,
+	TVOUT_MODE_576P,
+	TVOUT_MODE_480P,
+	TVOUT_MODE_720P50,
+	TVOUT_MODE_720P60,
+	TVOUT_MODE_1080I25,
+	TVOUT_MODE_1080I30,
+
+	TVOUT_MODE_SECAM,
+	TVOUT_MODE_PAL_M,
+	TVOUT_MODE_PAL_N,
+	TVOUT_MODE_PAL_CN,
+	TVOUT_MODE_1080P24,
+	TVOUT_MODE_1080P25,
+	TVOUT_MODE_1080P30,
+	TVOUT_MODE_1080P50,
+	TVOUT_MODE_1080P60,
+
+	TVOUT_MODE_576I_16TO9,
+	TVOUT_MODE_480I5994,
+	TVOUT_MODE_480I5994_16TO9,
+	TVOUT_MODE_480I60_16TO9,
+	TVOUT_MODE_576P50_16TO9,
+	TVOUT_MODE_480P5994,
+	TVOUT_MODE_480P5994_16TO9,
+	TVOUT_MODE_480P60_16TO9,
+	TVOUT_MODE_720P5994,
+	TVOUT_MODE_1080I5994,
+	TVOUT_MODE_1080P2397,
+	TVOUT_MODE_1080P5994,
+
+	TVOUT_MODE_720P5994_3DFP,
+	TVOUT_MODE_720P60_3DFP,
+	TVOUT_MODE_720P50_3DFP,
+	TVOUT_MODE_1080P2397_3DFP,
+	TVOUT_MODE_1080P24_3DFP,
+
+	TVOUT_MODE_1080I50_3DSS,
+	TVOUT_MODE_1080I5994_3DSS,
+	TVOUT_MODE_1080I60_3DSS,
+
+	TVOUT_MODE_720P50_3DTB,
+	TVOUT_MODE_720P5994_3DTB,
+	TVOUT_MODE_720P60_3DTB,
+	TVOUT_MODE_1080P2397_3DTB,
+	TVOUT_MODE_1080P24_3DTB,
+
+	TVOUT_RGB_640X480_60FPS,
+	TVOUT_RGB_800X600_60FPS,
+	TVOUT_RGB_1024X768_60FPS,
+       TVOUT_RGB_1280X720_60FPS,
+       TVOUT_RGB_800X480_60FPS,
+       TVOUT_RGB_1440X900_60FPS,
+       TVOUT_RGB_1280X1024_60FPS,
+       TVOUT_RGB_1360X768_60FPS,
+       TVOUT_RGB_1920X1080P30,
+       TVOUT_RGB_1920X1080P60,
+       TVOUT_RGB_1920X1080I30,
+       TVOUT_RGB_1366X768_60FPS,
+       TVOUT_RGB_640X480_5994FPS,
+       TVOUT_MODE_1600X1200_60FPS,
+} TVOUT_MODE;
+
+typedef enum
+{
+        DF_OUTPUT_CVBS_SVIDEO = 0,
+        DF_OUTPUT_YPBPR,
+        DF_OUTPUT_VGA
+} DF_OUTPUT_MODE;
+
+typedef struct DF_DEV_t {
+	unsigned int dev_minor;
+	DF_DEV_TYPE dev_type;
+	spinlock_t spin_lock;
+	unsigned int enable;
+	TVOUT_MODE tve_format;
+	char* name;
+} dfdev;
+
+typedef struct DF_OUTPUT_CONFIG_t_{
+	int gfx_output[2]; //gfx_layer_id
+	int vid_output[3]; //video_layer_id
+	DF_OUTPUT_MODE output_mode[2];//outif_id
+}DF_OUTPUT_CONFIG_t;
+
+typedef struct df_rect
+{
+        int left;
+        int right;
+        int top;
+        int bottom;
+}df_rect;
+
+typedef struct df_output_pos
+{
+	df_rect src;
+	df_rect dst;
+}df_output_pos;
+
+typedef struct _DF_OUTIF_FORMAT_INFO_
+{
+	int  mIsYUVorRGB;
+	int  mWidth;
+	int  mHeight;
+	int  mFPS;
+	int  mFreq;
+	int  mIsHD;
+	int  mVSyncPol;
+	int  mHSyncPol;
+	int  mHRes;
+	int  mHActive;
+	int  mHSyncFP;
+	int  mHSyncWidth;
+	int  mHSyncBP;
+	int  mVRes;
+	int  mVActline;
+	int  mVSyncFP;
+	int  mVSyncWidth;
+	int  mVSyncBP;
+	int  m3dEn;
+	int  m3dVactSpace;
+	int  mVidType;
+	int  mVidrptr;
+	int  mYCMuxEn;
+	int  mPALFmt;
+	int  mFmtIdx;
+	char *mFmtName;
+
+} df_out_if_timing;
+
+enum _DF_SCALER_COEFF_TYPE_
+{
+	DF_VIDEO1_Y_HFIR_COEFF_IDX = 0,//              0 : Video 1 HFIR Coeff
+	DF_VIDEO1_Y_VFIR_COEFF_IDX = 1,//              1 : Video 1 VFIR Coeff
+	DF_VIDEO2_Y_HFIR_COEFF_IDX = 2,//              2 : Video 2 HFIR Coeff
+	DF_VIDEO2_Y_VFIR_COEFF_IDX = 3,//              3 : Video 2 VFIR Coeff
+	DF_HD2SD_Y_HFIR_COEFF_IDX  = 4,//              4 : HD2SD 1 HFIR Coeff
+	DF_HD2SD_Y_VFIR_COEFF_IDX   =5,//              5 : HD2SD 1 VFIR Coeff
+};
+
+enum _DF_VIDEO_SCALER_CFG_
+{
+	//Scaler Coeff Cfg
+	DF_SCL_STEP_FRACTION_BIT_WIDTH  = 13,
+
+	DF_SCL_COEFF_FRACTION_BIT_WIDTH = 10,
+	DF_SCL_COEFF_INTREGER_BIT_WIDTH = 1,
+	DF_SCL_COEFF_POLARITY_BIT       = 15,
+
+	DF_SCL_WIDTH_MAX = 2048,
+	DF_SCL_FIR_TAP_MAX  = 32,
+
+	//Video Scaler Cfg
+	DF_VIDEO_SCL_LUMA_VFIR_TAP_NUM          = 4,
+	DF_VIDEO_SCL_LUMA_VFIR_PHASE_LOG2BITS   = 4,
+	DF_VIDEO_SCL_LUMA_VFIR_PHASE_NUM        = 1 << DF_VIDEO_SCL_LUMA_VFIR_PHASE_LOG2BITS,
+	DF_VIDEO_SCL_LUMA_HFIR_TAP_NUM          = 4,
+	DF_VIDEO_SCL_LUMA_HFIR_PHASE_LOG2BITS   = 4,
+	DF_VIDEO_SCL_LUMA_HFIR_PHASE_NUM        = 1 << DF_VIDEO_SCL_LUMA_HFIR_PHASE_LOG2BITS,
+
+	DF_VIDEO_SCL_CHROMA_VFIR_TAP_NUM        = 2,
+	DF_VIDEO_SCL_CHROMA_VFIR_PHASE_LOG2BITS = 4,
+	DF_VIDEO_SCL_CHROMA_VFIR_PHASE_NUM      = 1 << DF_VIDEO_SCL_CHROMA_VFIR_PHASE_LOG2BITS,
+	DF_VIDEO_SCL_CHROMA_HFIR_TAP_NUM        = 2,
+	DF_VIDEO_SCL_CHROMA_HFIR_PHASE_LOG2BITS = 4,
+	DF_VIDEO_SCL_CHROMA_HFIR_PHASE_NUM      = 1 << DF_VIDEO_SCL_CHROMA_HFIR_PHASE_LOG2BITS,
+
+	//HD2SD Capture Block
+	DF_HD2SD_SCL_LUMA_VFIR_TAP_NUM          = 4,
+	DF_HD2SD_SCL_LUMA_VFIR_PHASE_LOG2BITS   = 4,
+	DF_HD2SD_SCL_LUMA_VFIR_PHASE_NUM        = 1 << DF_HD2SD_SCL_LUMA_VFIR_PHASE_LOG2BITS,
+	DF_HD2SD_SCL_LUMA_HFIR_TAP_NUM          = 4,
+	DF_HD2SD_SCL_LUMA_HFIR_PHASE_LOG2BITS   = 4,
+	DF_HD2SD_SCL_LUMA_HFIR_PHASE_NUM        = 1 << DF_HD2SD_SCL_LUMA_HFIR_PHASE_LOG2BITS,
+
+	DF_HD2SD_SCL_CHROMA_VFIR_TAP_NUM        = 2,
+	DF_HD2SD_SCL_CHROMA_VFIR_PHASE_LOG2BITS = 4,
+	DF_HD2SD_SCL_CHROMA_VFIR_PHASE_NUM      = 1 << DF_HD2SD_SCL_CHROMA_VFIR_PHASE_LOG2BITS,
+	DF_HD2SD_SCL_CHROMA_HFIR_TAP_NUM        = 2,
+	DF_HD2SD_SCL_CHROMA_HFIR_PHASE_LOG2BITS = 4,
+	DF_HD2SD_SCL_CHROMA_HFIR_PHASE_NUM      = 1 << DF_HD2SD_SCL_CHROMA_HFIR_PHASE_LOG2BITS,
+
+	//Gfx Horizontal Scaler
+	DF_GFX_SCL_STEP_FRACTION_BIT_WIDTH  = 10,
+	DF_GFX_SCL_HFIR_TAP_NUM        = 2,
+	DF_GFX_SCL_HFIR_PHASE_LOG2BITS = 6,
+	DF_GFX_SCL_HFIR_PHASE_NUM      = 1 << DF_GFX_SCL_HFIR_PHASE_LOG2BITS,
+};
+
+typedef struct{
+	wait_queue_head_t wait;
+	unsigned int count;
+	int is_display;
+	struct fb_info *cur_fb_info;
+}CNC_FB_INTERRUPT;
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,241 @@
+/*
+ *  arch/arm/mach-celestial/include/mach/cnc1900.h
+ *
+ *  This file contains the hardware definitions of the cavium Celestial CNC1900 1900 FPGA-V7 Platform.
+ *
+ *  Copyright (C) 2012 Cavium
+ */
+
+#ifndef __ASM_ARCH_CNC1900_H
+#define __ASM_ARCH_CNC1900_H
+
+/* macro to get at IO space when running virtually */
+#define IO_ADDRESS(phys) (0xF0000000 + ((((phys) >> 4) & 0x0ff00000) + ((phys) & 0xFFFFFFF)))
+
+#include <mach/mem_define.h>
+
+#define PCLK_KHZ                   45000
+#define PCLK_MHZ                   45
+
+
+
+
+
+
+
+
+
+
+
+/** Cortex-A9 Private Memory Region **/
+#define CNC1900_CA9_PMR                 0x80020000
+/* Snoop Control Unit */
+#define CNC1900_CA9_SCU                 (CNC1900_CA9_PMR + 0x00000000)
+/* GIC CPU Interface */
+#define CNC1900_CA9_GIC_CPUIF           (CNC1900_CA9_PMR + 0x00000100)
+/* Global Timer */
+#define CNC1900_CA9_GBL_TIMER           (CNC1900_CA9_PMR + 0x00000200)
+/* Private Timer and Watchdog */
+#define CNC1900_CA9_TWD                 (CNC1900_CA9_PMR + 0x00000600)
+/* GIC Distributor */
+#define CNC1900_CA9_GIC_DIST            (CNC1900_CA9_PMR + 0x00001000)
+/* Private Timer */
+#define CNC1900_CA9_PVT_TIMER           (CNC1900_CA9_TWD + 0x00000000)
+/* Private Watchdog */
+#define CNC1900_CA9_PVT_WDT             (CNC1900_CA9_TWD + 0x00000020)
+
+
+/** L2 Cache Controller **/
+#define CNC1900_L2X0                    0x80030000
+
+
+/** Trust-Zone APB **/
+#define CNC1900_TZ_APB                  0x80040000
+/* TZ Address Space Controller 0 */
+#define CNC1900_TZ_ASC0                 (CNC1900_TZ_APB + 0x00000000)
+/* TZ Address Space Controller 1 */
+#define CNC1900_TZ_ASC1                 (CNC1900_TZ_APB + 0x00010000)
+/* TZ Config */
+#define CNC1900_TZ_CFG                  (CNC1900_TZ_APB + 0x00020000)
+/* TZ Timer */
+#define CNC1900_TZ_TIMER                (CNC1900_TZ_APB + 0x00030000)
+
+
+/** On-chip Peripheral **/
+#define CNC1900_PERIPH_BASE             0x80100000
+/* Static Memory Controller - SMC */
+#define CNC1900_SMC                     0x80100000
+/* Dynamic Memory Controller - DMC */
+#define CNC1900_DMC                     0x80110000
+/* Serial Peripheral Interface - SPI */
+#define CNC1900_SPI                     0x80150000
+/* TV Encoder - TVE */
+#define CNC1900_TVE                     0x80160000
+/* I2C0 */
+#define CNC1900_I2C0                    0x80170000
+#define VA_I2C_BASE                IO_ADDRESS(CNC1900_I2C0)
+
+/* Panel CTL */
+#define CNC1900_PCTL                    0x80172000
+#define PA_FPC_BASE                    CNC1900_PCTL
+
+#define VA_FPC_BASE			IO_ADDRESS(CNC1900_PCTL)
+/* I2C1 */
+#define CNC1900_I2C1                    0x80174000
+/* IR Repeater */
+#define CNC1900_IR_REPEATER      0x801E7000
+/* SMIO */
+#define CNC1900_SMIO                    0x801F0000
+/* UART 0 */
+#define CNC1900_UART0                   0x801F1000
+/* UART 1 */
+#define CNC1900_UART1                   0x801F2000
+/* USB EHCI */
+#define CNC1900_USB_EHCI                0x80200000
+/* USB OHCI */
+#define CNC1900_USB_OHCI                0x80210000
+/* Crypto Engine */
+#define CNC1900_CRYPTO                  0x80240000
+/* PCMCIA */
+#define CNC1900_PCMCIA                  0x80250000
+/* GPIO */
+#define CNC1900_GPIO                    0x80260000
+#define VA_GPIO_BASE	IO_ADDRESS(CNC1900_GPIO)
+/* SD0 */
+#define CNC1900_SD0                     0x80290000
+/* SD1 */
+#define CNC1900_SD1                     0x802A0000
+/* USB OTG */
+#define CNC1900_USB_OTG                 0x802C0000
+/* HDMI */
+#define CNC1900_HDMI                    0x80400000
+#define VA_HDMI_BASE                    IO_ADDRESS(CNC1900_HDMI)
+#define CNC1900_HDMI_PHY                0x80401800
+#define VA_HDMI_PHY_BASE                IO_ADDRESS(CNC1900_HDMI_PHY)
+#define CNC1900_MHL_PHY                 0x80403800
+#define VA_MHL_PHY_BASE                 IO_ADDRESS(CNC1900_MHL_PHY)
+
+/** Peripheral Space Size **/
+#define CNC1900_PERIPH_SIZE             0x00500000
+
+
+/** CoreSight **/
+#define CNC1900_CORESIGHT               0x90000000
+
+
+/** Static Memory **/
+#define CNC1900_SM_BASE                 0xA0000000
+/* Static Memory - CS0 */
+#define CNC1900_SM_CS0                  (CNC1900_SM_BASE + 0x04000000)
+/* Static Memory - CS1 */
+#define CNC1900_SM_CS1                  (CNC1900_SM_BASE + 0x06000000)
+/* Static Memory - CS2 */
+#define CNC1900_SM_CS2                  (CNC1900_SM_BASE + 0x08000000)
+/* Static Memory - CS3 */
+#define CNC1900_SM_CS3                  (CNC1900_SM_BASE + 0x0A000000)
+
+
+/** Media Processor **/
+#define CNC1900_MEDIA_BASE              0xB1000000
+/* Audio */
+#define CNC1900_AUDIO                   (CNC1900_MEDIA_BASE + 0x00200000)
+/* Ethernet */
+#define CNC1900_ETH                     (CNC1900_MEDIA_BASE + 0x00400000)
+/* Video */
+#define CNC1900_VIDEO                   (CNC1900_MEDIA_BASE + 0x00600000)
+/* VPP */
+#define CNC1900_VPP                     (CNC1900_MEDIA_BASE + 0x00800000)
+/* VPB */
+#define CNC1900_VPB                     (CNC1900_MEDIA_BASE + 0x00C00000)
+
+
+/* Audio Common */
+#define CNC1900_AUDIO_COMMON            (CNC1900_AUDIO + 0x00000000)
+/* Audio I2S */
+#define CNC1900_AUDIO_I2S               (CNC1900_AUDIO + 0x00001000)
+/* Audio SPDIF */
+#define CNC1900_AUDIO_SPDIF             (CNC1900_AUDIO + 0x00002000)
+/* Audio IFIFO */
+#define CNC1900_AUDIO_IFIFO             (CNC1900_AUDIO + 0x00004000)
+
+
+/* Video Common */
+#define CNC1900_VIDEO_COMMON            (CNC1900_VIDEO + 0x00000000)
+/* CODA */
+#define CNC1900_VIDEO_CODA              (CNC1900_VIDEO + 0x00040000)
+/* Video RISC cpu */
+#define CNC1900_VIDEO_RISC_CPU          (CNC1900_VIDEO + 0x00090000)
+
+
+/** System Cotrol */
+#define CNC1900_SYSCTL_BASE             0xB2000000
+/* Pin Mux */
+#define CNC1900_PIN_MUX                 (CNC1900_SYSCTL_BASE + 0x00110000)
+#define CNC1900_PIN_MUX_SIZE	(0x100)
+
+
+
+/*bin added*/
+#define PA_IO_REGS_BASE            0x80100000
+#define IO_REGS_SIZE               0x500000
+#define VA_IO_REGS_BASE            IO_ADDRESS(PA_IO_REGS_BASE)
+
+#define PA_IO_GRAPHICS_BASE        0xB0000000
+
+#define IO_GRAPHICS_SIZE           0x200 // bigger than required (0x100)
+#define VA_IO_GRAPHICS_BASE        IO_ADDRESS(PA_IO_GRAPHICS_BASE)
+
+#define PA_IO_MEDIA_PROCESSOR_BASE 0xB1000000
+#define IO_MEDIA_PROCESSOR_SIZE    0xf00000
+#define VA_IO_MEDIA_PROCESSOR_BASE IO_ADDRESS(PA_IO_MEDIA_PROCESSOR_BASE)
+
+#define PA_IO_SYSTEM_CONTROL_BASE 0xB2100000
+#define IO_SYSTEM_CONTROL_SIZE    0x100000
+#define VA_IO_SYSTEM_CONTROL_BASE IO_ADDRESS(PA_IO_SYSTEM_CONTROL_BASE)
+
+#define PA_IO_LINE_BUFFER_BASE  0x80000000
+#define IO_LINE_BUFFER_SIZE             0x20000
+#define VA_IO_LINE_BUFFER_BASE      IO_ADDRESS(PA_IO_LINE_BUFFER_BASE)
+
+#define PA_CRYPTO_BASE             (PA_IO_REGS_BASE + 0x140000)
+#define VA_CRYPTO_BASE             IO_ADDRESS(PA_CRYPTO_BASE)
+
+#define PA_XPORT_REG_BASE          0xB1400000
+#define VA_XPORT_BASE              IO_ADDRESS(PA_XPORT_REG_BASE)
+
+#define CAV_TIMER_LOAD			0x00
+#define CAV_TIMER_COUNTER		0x04
+#define CAV_TIMER_CONTROL		0x08
+#define CAV_TIMER_INTSTAT		0x0C
+
+#define CAV_WDOG_LOAD			0x20
+#define CAV_WDOG_COUNTER		0x24
+#define CAV_WDOG_CONTROL		0x28
+#define CAV_WDOG_INTSTAT		0x2C
+#define CAV_WDOG_RESETSTAT		0x30
+#define CAV_WDOG_DISABLE		0x34
+
+#define CAV_TIMER_CONTROL_ENABLE	(1 << 0)
+#define CAV_TIMER_CONTROL_ONESHOT	(0 << 1)
+#define CAV_TIMER_CONTROL_PERIODIC	(1 << 1)
+#define CAV_TIMER_CONTROL_IT_ENABLE	(1 << 2)
+
+#define CAV_WDOG_CONTROL_ENABLE	(1 << 0)
+#define CAV_WDOG_CONTROL_ONESHOT	(0 << 1)
+#define CAV_WDOG_CONTROL_PERIODIC	(1 << 1)
+#define CAV_WDOG_CONTROL_IT_ENABLE	(1 << 2)
+
+#define GBL_TIMER_COUNTER_L 0x00
+#define GBL_TIMER_COUNTER_H 0x04
+#define GBL_TIMER_CONTROL   0x08
+#define GBL_TIMER_INTSTAT   0x0C
+#define GBL_TIMER_COMPARE_L 0x10
+#define GBL_TIMER_COMPARE_H 0x14
+#define GBL_TIMER_INCREMENT 0x18
+
+#define TIMER_CTRL_EN  (1 << 0)
+#define TIMER_CTRL_COM (1 << 1)
+#define TIMER_CTRL_IRQ (1 << 2)
+#define TIMER_CTRL_INC (1 << 3)
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_power_clk.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_power_clk.h
--- linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_power_clk.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_power_clk.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,246 @@
+#ifndef _CNC1900_POWER_CLK_H_
+#define _CNC1900_POWER_CLK_H_
+
+#ifdef __cplusplus
+extern "C"{
+#endif
+
+#define POWER_BASE 'P'
+#define USB_POWER_DOWN          _IOW (POWER_BASE, 0, int)
+#define XPORT_CLK_DOWN          _IOW (POWER_BASE, 1, int)
+
+#define VIB_CLK_DOWN            _IOW (POWER_BASE, 2, int)
+#define VPB_CLK_DOWN            _IOW (POWER_BASE, 2, int)
+
+#define AUD_CLK_DOWN            _IOW (POWER_BASE, 3, int)
+#define CRYPTO_CLK_DOWN         _IOW (POWER_BASE, 4, int)
+#define GRAPHICS_CLK_DOWN       _IOW (POWER_BASE, 5, int)
+#define DF_CLK_DOWN             _IOW (POWER_BASE, 6, int)
+#define VIDECOD_CLK_DOWN        _IOW (POWER_BASE, 7, int)
+#define AUDDACIF_CLK_DOWN       _IOW (POWER_BASE, 8, int)
+#define SD_CLK_DOWN             _IOW (POWER_BASE, 9, int)
+#define TVE1_CLK_DOWN           _IOW (POWER_BASE, 10, int)
+#define TVE0_CLK_DOWN           _IOW (POWER_BASE, 11, int)
+#define AUD_POWER_DOWN          _IOW (POWER_BASE, 12, int)
+#define VID_POWER_DOWN          _IOW (POWER_BASE, 13, int)
+#define AUD_PLLCLK_DOWN         _IOW (POWER_BASE, 14, int)
+#define VDAC0_POWER_DOWN	    _IOW (POWER_BASE, 15, int)
+#define VDAC1_POWER_DOWN	    _IOW (POWER_BASE, 16, int)
+#define HDMI_POWER_DOWN			_IOW (POWER_BASE, 17, int)
+#define JPEG_CLK_DOWN           _IOW (POWER_BASE, 18, int)
+#define AHB2_CLK_DOWN           _IOW (POWER_BASE, 19, int)
+#define CEC_CLK_DOWN            _IOW (POWER_BASE, 20, int)
+#define IR_CLK_DOWN             _IOW (POWER_BASE, 21, int)
+#define VPBIN_CLK_DOWN          _IOW (POWER_BASE, 22, int)
+
+typedef enum _POWER_MODE_
+{
+	_clock_sleep =0,
+	_clock_wake  =1,
+}POWER_MODE;
+
+typedef enum _CLOCK_RESET_
+{
+  _do_reset =0,
+  _do_set   =1,
+}CLOCK_RESET;
+
+typedef enum _HDMI_SEL_
+{
+	_sel_ttl =0,
+	_sel_vib   =1,
+}HDMI_SEL;
+
+typedef enum _CLOCK_ENA_
+{
+        _clock_enable =1,
+        _clock_disable =0,
+}CLOCK_ENA;
+
+//Coda
+/*
+void clock_coda_setclock(double codapll_clk, unsigned short codaaclk_postdiv, unsigned short codacclk_postdiv, unsigned short use_codapll_for_cclk );
+*/
+
+//Display
+typedef enum _CLOCK_DISP0_MODE_e_ {                
+    _YUV_1080P_60Hz             ,          
+    _YUV_1080P_50Hz             ,          
+    _YUV_1080P_30Hz             ,          
+    _YUV_1080P_25Hz             ,          
+    _YUV_1080P_24Hz             ,          
+    _YUV_1080I_60Hz             ,          
+    _YUV_1080I_50Hz             ,          
+    _YUV_720P_60Hz              ,          
+    _YUV_720P_50Hz              ,          
+
+    _YUV_1080P_59p94Hz          ,          
+    _YUV_1080P_29p97Hz          ,          
+    _YUV_1080P_23p98Hz          ,          
+    _YUV_1080I_59p94Hz          ,          
+    _YUV_720P_59p94Hz           ,          
+
+    _YUV_576P_50Hz              ,          
+    _YUV_480P_59p94Hz              ,          
+    _YUV_480P_60Hz           ,          
+    _YUV_PAL                    ,          
+    _YUV_NTSC                   ,          
+    _YUV_480I_60Hz           ,          
+
+    _RGB_DMT_640x350_85Hz       ,          
+    _RGB_DMT_640x400_85Hz       ,          
+    _RGB_DMT_720x400_85Hz       ,          
+    _RGB_DMT_640x480_60Hz       ,          
+    _RGB_DMT_640x480_72Hz       ,          
+    _RGB_DMT_640x480_75Hz       ,          
+    _RGB_DMT_640x480_85Hz       ,          
+    _RGB_DMT_800x600_56Hz       ,          
+    _RGB_DMT_800x600_60Hz       ,          
+    _RGB_DMT_800x600_72Hz       ,          
+    _RGB_DMT_800x600_75Hz       ,          
+    _RGB_DMT_800x600_85Hz       ,          
+    _RGB_DMT_800x600_120Hz_RED  ,          
+
+    _RGB_DMT_848x480_60Hz       ,          
+
+    _RGB_DMT_1024x768_43Hz      ,          
+    _RGB_DMT_1024x768_60Hz      ,          
+    _RGB_DMT_1024x768_70Hz      ,          
+    _RGB_DMT_1024x768_75Hz      ,          
+    _RGB_DMT_1024x768_85Hz      ,          
+    _RGB_DMT_1024x768_120Hz_RED ,          
+
+    _RGB_DMT_1152x864_75Hz      ,          
+
+    _RGB_DMT_1280x768_60Hz_RED  ,          
+    _RGB_DMT_1280x768_60Hz      ,          
+    _RGB_DMT_1280x768_75Hz      ,          
+    _RGB_DMT_1280x768_85Hz      ,          
+    _RGB_DMT_1280x768_120Hz_RED ,          
+
+    _RGB_DMT_1280x800_60Hz_RED  ,          
+    _RGB_DMT_1280x800_60Hz      ,          
+    _RGB_DMT_1280x800_75Hz      ,          
+    _RGB_DMT_1280x800_85Hz      ,          
+    _RGB_DMT_1280x800_120Hz_RED ,          
+
+    _RGB_DMT_1280x960_60Hz      ,          
+    _RGB_DMT_1280x960_85Hz      ,          
+
+    _RGB_DMT_1280x1024_60Hz     ,          
+    _RGB_DMT_1280x1024_75Hz     ,          
+    _RGB_DMT_1280x1024_85Hz     ,          
+
+    _RGB_DMT_1360x768_60Hz      ,          
+    _RGB_DMT_1360x768_120Hz_RED ,          
+
+    _RGB_DMT_1400x1050_60Hz_RED ,          
+    _RGB_DMT_1400x1050_60Hz     ,          
+    _RGB_DMT_1400x1050_75Hz     ,          
+
+    _RGB_DMT_1440x900_60Hz_RED  ,          
+    _RGB_DMT_1440x900_60Hz      ,          
+    _RGB_DMT_1440x900_75Hz      ,          
+    _RGB_DMT_1440x900_85Hz      ,          
+
+    _RGB_DMT_1600x1200_60Hz     ,          
+
+    _RGB_DMT_1680x1050_60Hz_RED ,          
+    _RGB_DMT_1680x1050_60Hz     ,          
+
+    _RGB_DMT_1920x1200_60Hz_RED,
+    _RGB_DMT_640x480_59P94Hz,
+}CLOCK_DISP0_MODE;
+
+void clock_disp0_setclock(CLOCK_DISP0_MODE mode_disp0);
+
+typedef enum _CLOCK_DISP1_MODE_e_
+{
+    _YUV_576P_50Hz_disp1,
+    _YUV_480P_60Hz_disp1,
+    _YUV_PAL_disp1,
+    _YUV_NTSC_disp1,
+    _YUV_SECAM_disp1,
+    _YUV_PAL_M_disp1,
+    _YUV_PAL_N_disp1,
+    _YUV_PAL_CN_disp1,
+}CLOCK_DISP1_MODE;
+
+void clock_disp1_setclock(CLOCK_DISP1_MODE mode_disp1);
+
+//Audio
+typedef enum _AUDIO_CLOCK_MODE_e_
+{
+	_AUDIO_192KHz       ,
+	_AUDIO_176KHZ		,
+	_AUDIO_128KHZ		,
+	_AUDIO_96KHz 		,
+	_AUDIO_88_2KHz		,
+	_AUDIO_64KHz		,
+	_AUDIO_48KHz		,
+	_AUDIO_44_1KHz		,
+	_AUDIO_32KHz		,
+	_AUDIO_24KHz		,
+	_AUDIO_22_05KHz		,
+	_AUDIO_16KHz		,
+	_AUDIO_12KHz		,
+	_AUDIO_11_025KHz	,
+	_AUDIO_8KHz	        ,
+}AUDIO_CLOCK_MODE;
+
+
+void clock_audio_setclock(AUDIO_CLOCK_MODE audclk_rate);
+
+//Reset
+void clock_xport_reset(CLOCK_RESET ResetOrSet);
+void clock_ether_reset(CLOCK_RESET ResetOrSet);
+void clock_audio_reset(CLOCK_RESET ResetOrSet);
+void clock_crypto_reset(CLOCK_RESET ResetOrSet);
+void clock_video_reset(CLOCK_RESET ResetOrSet);
+void clock_gfx_reset(CLOCK_RESET ResetOrSet);
+void clock_dfr_reset(CLOCK_RESET ResetOrSet);
+void clock_disp0_reset(CLOCK_RESET ResetOrSet);
+void clock_disp1_reset(CLOCK_RESET ResetOrSet);
+void clock_tve0_reset(CLOCK_RESET ResetOrSet);
+void clock_tve1_reset(CLOCK_RESET ResetOrSet);
+void clock_vib_reset(CLOCK_RESET ResetOrSet);
+void clock_jpeg_reset(CLOCK_RESET ResetOrSet);
+void clock_coda_reset(CLOCK_RESET ResetOrSet);
+void clock_hdmi_reset(CLOCK_RESET ResetOrSet);
+void clock_hdmi_bypass(HDMI_SEL vpbOrdisp);
+void clock_spdif_reset(CLOCK_RESET ResetOrSet);
+void clock_dramporta_reset(CLOCK_RESET ResetOrSet);
+void clock_ir_reset(CLOCK_RESET ResetOrSet);
+
+/* Clock Enable/disable */
+void clock_dac0_enaclock(CLOCK_ENA ClockEna);
+void clock_dac1_enaclock(CLOCK_ENA ClockEna);
+
+void clock_dram_enaclock(CLOCK_ENA ClockEna);
+void clock_tve0_enaclock(CLOCK_ENA ClockEna);
+void clock_tve1_enaclock(CLOCK_ENA ClockEna);
+void clock_sdio_enaclock(CLOCK_ENA ClockEna);
+void clock_audiopll_enaclock(CLOCK_ENA ClockEna);
+void clock_jpeg_enaclock(CLOCK_ENA ClockEna);
+void clock_coda_enaclock(CLOCK_ENA ClockEna);
+void clock_df_enaclock(CLOCK_ENA ClockEna);
+void clock_gpu_enaclock(CLOCK_ENA ClockEna);
+void clock_ahb2_enaclock(CLOCK_ENA ClockEna);
+void clock_crypto_enaclock(CLOCK_ENA ClockEna);
+void clock_xport_enaclock(CLOCK_ENA ClockEna); /* It will control eth also.*/
+void clock_audio_enaclock(CLOCK_ENA ClockEna);
+void clock_video_enaclock(CLOCK_ENA ClockEna);
+void clock_dramporta_enaclock(CLOCK_ENA ClockEna);
+void clock_usb_enaclock(CLOCK_ENA ClockEna);
+void clock_cec_enaclock(CLOCK_ENA ClockEna);
+void clock_ir_enaclock(CLOCK_ENA ClockEna);
+void clock_vpb_enaclock(CLOCK_ENA ClockEna);
+void clock_vpbinput_enaclock(CLOCK_ENA ClockEna);
+void clock_cpu_enaclock(CLOCK_ENA ClockEna); /* In low power mode, this one can be set by Audio. others, no need to call this one.*/
+void clock_cpusrc_enaclock(CLOCK_ENA ClockEna); /* Should be always write 1 */
+
+#ifdef __cplusplus
+}
+#endif
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/arch/arm/mach-celestial/include/mach/cnc1900_scalor_coef.h linux-linaro-3.4-2012.05-1_cavium/arch/arm/mach-celestial/include/mach/cnc1900_scalor_coef.h
